(function () {
    "use strict";

    angular.module('core').controller('representanteDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'empresaService', 'contatoService'];

    function controller($scope, $timeout, $state, $stateParams, empresaService, contatoService) {
        $scope.initializeLayout('Representante');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
        };
        $scope.popups = {
            contatos: { ativo: false },
            filiais: { ativo: false },
        };
        $scope.auxiliar = {
            contatos: { data: [], carregando: false, vazio: true, count: 0, args: { filtro: { Empresa: { ID: decodeURIComponent($stateParams.id) } }, skip: 0, take: 999999 } },
            filiais: { data: [], carregando: false, vazio: true, count: 0, args: { matrizID: decodeURIComponent($stateParams.id), skip: 0, take: 999999 } },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            empresaService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.getAllFilha = function () {
            $scope.auxiliar.filiais.carregando = true;
            $scope.auxiliar.filiais.vazio = false;
            empresaService
                .getAllFilha($scope.auxiliar.filiais.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.filiais.data);
                        }
                        $scope.auxiliar.filiais.carregando = false;
                        $scope.auxiliar.filiais.vazio = ($scope.auxiliar.filiais.data.length == 0);
                    },
                    function (_error) {
                        $scope.auxiliar.filiais.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getAllContato = function () {
            $scope.auxiliar.contatos.carregando = true;
            $scope.auxiliar.contatos.vazio = false;
            contatoService
                .getAll($scope.auxiliar.contatos.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            console.error(response.Exception);
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.contatos.data);
                        }
                        $scope.auxiliar.contatos.carregando = false;
                        $scope.auxiliar.contatos.vazio = !response.Data.length;
                    },
                    function (_error) {
                        $scope.auxiliar.contatos.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    });
        }

        $scope.refresh = function () {
            $scope.get();
        };

        $scope.toggleContatos = function () {
            $scope.popups.contatos.ativo = !$scope.popups.contatos.ativo;
            if ($scope.popups.contatos.ativo)
                $scope.getAllContato();
        };
        $scope.toggleFiliais = function () {
            $scope.popups.filiais.ativo = !$scope.popups.filiais.ativo;
            if ($scope.popups.filiais.ativo)
                $scope.getAllFilha();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();